package com.SocialApp;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.ContactFilter;
import com.badlogic.gdx.physics.box2d.ContactListener;

public class CharacterObject extends GameObject {
	
	private boolean isBusy; //flag for character status
	private int busyCounter = 0;
	private Vector2 otherBodyVel;
	
	public CharacterObject(Body character, Vector2 bCoords) {		
		super(character, bCoords);
		
		walk();
		
		
	}
	
	public void updateObject() {
		
		super.updateTexture();
		
		if(busyCounter < 0) { //if time limit is reached
			isBusy = false;
			body.setLinearVelocity(getNewVelocity(otherBodyVel));
			body.setActive(true); //re activate body
		}
		
		else if(isBusy) {
			//countdown time
			busyCounter--;
		}
		else if(Math.random() < 0.01) //Reset character walk 0.01% of the time
			walk();
	}
	
	public void startConversing(Body otherChar) {
		
		otherBodyVel = otherChar.getLinearVelocity();
		body.setActive(false);
		isBusy = true;
		busyCounter = 100;
		
		
	}
	
	private void walk() {
		
		super.body.setLinearVelocity(new Vector2((float) (Math.random()*100 - Math.random()*100),(float) (Math.random()*100 - Math.random()*100) ));
		
	}	
	
	private Vector2 getNewVelocity(Vector2 otherVel) {
		
		Vector2 newVel = new Vector2(0,0);
		
		/* NEED TO RESOLVE A MEANS TO DETECT IF ONE BODY IS IN THE OTHERS COLLISIONS RANGE (body angle +- 90) */
//		float[] collideRange = {(body.getLinearVelocity().angle()+90) % 360, (Math.abs(body.getLinearVelocity().angle()-90) % 360)};
//		
//		newVel = (otherVel.rotate(180).angle() <= collideRange[0] || otherVel.rotate(180).angle() >= collideRange[1] ? 
//				body.getLinearVelocity().rotate(180) : body.getLinearVelocity());
//		
//		System.out.println("1st body angle: "+body.getLinearVelocity().angle()+" 2nd body angle : "+otherVel.angle() + "new angle : "+newVel.angle());
//		
		otherVel = new Vector2(0,0);
		
		return newVel;
		
	}

}
