package com.SocialApp;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.scenes.scene2d.Actor;

public class GameObject {
	
	Body body;
	Actor actor;
	float aX, aY;
	Vector2 origV; //coordinates for starting position of body
	
	public GameObject(Body b, Vector2 oV) {
		
		body = b;
		origV = oV;
		
	}
	
	public void setActor(Actor a) {
		actor = a;
		updateTexture();
	}
	
	protected void updateTexture() {
		
		translateActorCoord();
		
		//set Actor coordinates to bodies location;
		actor.x = aX;
		actor.y = aY;
	}
	
	private void translateActorCoord() {
		
		//center actor on body
		aX = (float) body.getPosition().x - actor.width/2;
		aY = (float) body.getPosition().y - actor.height/2;
		
		//negate body's local coordinates against center of world
		aX += Gdx.graphics.getWidth()/2 + origV.x;
		aY += Gdx.graphics.getHeight()/2 + origV.y;
		
		
	}

}
